--- old/usr/src/tools/smatch/src/check_access_ok_math.c	Mon Nov 18 13:18:41 2019
+++ new/usr/src/tools/smatch/src/check_access_ok_math.c	Mon Nov 18 13:18:41 2019
@@ -76,24 +76,15 @@
 static void split_asm_constraints(struct expression_list *expr_list)
 {
 	struct expression *expr;
-        int state = 0;
 	int i;
 
 	i = 0;
         FOR_EACH_PTR(expr_list, expr) {
-
-                switch (state) {
-                case 0: /* identifier */
-                case 1: /* constraint */
-                        state++;
-                        continue;
-                case 2: /* expression */
-                        state = 0;
-			if (i == 1)
-				match_size(expr);
-			i++;
-                        continue;
-                }
+		i++;
+		if (expr->type != EXPR_ASM_OPERAND)
+			continue;
+		if (i == 1)
+			match_size(expr->expr);
         } END_FOR_EACH_PTR(expr);
 }
 
--- /dev/null	Mon Nov 18 13:18:41 2019
+++ new/usr/src/tools/smatch/src/check_arm64_tagged.c	Mon Nov 18 13:18:42 2019
@@ -0,0 +1,255 @@
+/*
+ * Copyright (C) 2019 ARM.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see http://www.gnu.org/copyleft/gpl.txt
+ */
+
+#include "smatch.h"
+#include "smatch_extra.h"
+#include "smatch_function_hashtable.h"
+
+static bool expr_has_memory_addr(struct expression *expr);
+
+static DEFINE_HASHTABLE_SEARCH(search_symbol, char, char);
+static DEFINE_HASHTABLE_INSERT(insert_symbol, char, char);
+static struct hashtable *symbols;
+
+static void match_assign(struct expression *expr)
+{
+	char *left_name;
+	struct symbol *left_sym;
+
+	left_name = expr_to_var_sym(expr->left, &left_sym);
+	if (!left_name || !left_sym)
+		return;
+
+	/*
+	 * Once we have spotted a symbol of interest (one that may hold
+	 * an untagged memory address), we keep track of any assignments
+	 * made, such that we can also treat the assigned symbol as something
+	 * of interest. This tracking is limited in scope to the function.
+	 */
+	if (expr_has_memory_addr(expr->right))
+		insert_symbol(symbols, left_name, left_name);
+}
+
+static void match_endfunc(struct symbol *sym)
+{
+	destroy_function_hashtable(symbols);
+	symbols = create_function_hashtable(4000);
+}
+
+static bool expr_has_untagged_symbol(struct expression *expr)
+{
+	char *name;
+	struct symbol *sym;
+
+	if (expr->type != EXPR_SYMBOL)
+		return false;
+
+	name = expr_to_var_sym(expr, &sym);
+	if (!name || !sym)
+		return false;
+
+	/* See if this is something we already know is of interest */
+	if (search_symbol(symbols, name))
+		return true;
+
+	return false;
+}
+
+static bool expr_has_untagged_member(struct expression *expr)
+{
+	if (expr->type != EXPR_DEREF)
+		return false;
+
+	if (!strcmp(expr->member->name, "vm_start") ||
+	    !strcmp(expr->member->name, "vm_end") ||
+	    !strcmp(expr->member->name, "addr_limit"))
+		return true;
+
+	return false;
+}
+
+static bool expr_has_macro_with_name(struct expression *expr, const char *macro_name)
+{
+	char *name;
+
+	name = get_macro_name(expr->pos);
+	return (name && !strcmp(name, macro_name));
+}
+
+static bool expr_has_untagged_macro(struct expression *expr)
+{
+	if (expr_has_macro_with_name(expr, "PAGE_SIZE") ||
+	    expr_has_macro_with_name(expr, "PAGE_MASK") ||
+	    expr_has_macro_with_name(expr, "TASK_SIZE"))
+		return true;
+
+	/**
+	 * We can't detect a marco (such as PAGE_MASK) inside another macro
+	 * such as offset_in_page, therefore we have to detect the outer macro
+	 * instead.
+	 */
+	if (expr_has_macro_with_name(expr, "offset_in_page"))
+		return true;
+
+	return false;
+}
+
+/*
+ * Identify expressions that contain memory addresses, in the future
+ * we may use annotations on symbols or function parameters.
+ */
+static bool expr_has_memory_addr(struct expression *expr)
+{
+	if (expr->type == EXPR_PREOP || expr->type == EXPR_POSTOP)
+		expr = strip_expr(expr->unop);
+
+	if (expr_has_untagged_member(expr))
+		return true;
+
+	if (expr_has_untagged_macro(expr))
+		return true;
+
+	if (expr_has_untagged_symbol(expr))
+		return true;
+
+	return false;
+}
+
+int rl_is_larger_or_equal(struct range_list *rl, sval_t sval)
+{
+	struct data_range *tmp;
+
+	FOR_EACH_PTR(rl, tmp) {
+		if (sval_cmp(tmp->max, sval) >= 0)
+			return 1;
+	} END_FOR_EACH_PTR(tmp);
+	return 0;
+}
+
+int rl_range_has_min_value(struct range_list *rl, sval_t sval)
+{
+	struct data_range *tmp;
+
+	FOR_EACH_PTR(rl, tmp) {
+		if (!sval_cmp(tmp->min, sval)) {
+			return 1;
+		}
+	} END_FOR_EACH_PTR(tmp);
+	return 0;
+}
+
+static bool rl_is_tagged(struct range_list *rl)
+{
+	sval_t invalid = { .type = &ullong_ctype, .value = (1ULL << 56) };
+	sval_t invalid_kernel = { .type = &ullong_ctype, .value = (0xff8ULL << 52) };
+
+	/*
+	 * We only care for tagged addresses, thus ignore anything where the
+	 * ranges of potential values cannot possibly have any of the top byte
+	 * bits set.
+	 */
+	if (!rl_is_larger_or_equal(rl, invalid))
+		return false;
+
+	/*
+	 * Tagged addresses are untagged in the kernel by using sign_extend64 in
+	 * the untagged_addr macro. For userspace addresses bit 55 will always
+	 * be 0 and thus this has the effect of clearing the top byte. However
+	 * for kernel addresses this is not true and the top bits end up set to
+	 * all 1s. The untagged_addr macro results in leaving a gap in the range
+	 * of possible values which can exist, thus let's look for a tell-tale
+	 * range which starts from (0xff8ULL << 52).
+	 */
+	if (rl_range_has_min_value(rl, invalid_kernel))
+		return false;
+
+	return true;
+}
+
+static void match_condition(struct expression *expr)
+{
+	struct range_list *rl = NULL;
+	struct expression *val = NULL;
+        struct symbol *type;
+	char *var_name;
+
+	/*
+	 * Match instances where something is compared against something
+	 * else - we include binary operators as these are commonly used
+	 * to make a comparison, e.g. if (start & ~PAGE_MASK).
+	 */
+	if (expr->type != EXPR_COMPARE &&
+	    expr->type != EXPR_BINOP)
+		return;
+
+	/*
+	 * Look on both sides of the comparison for something that shouldn't
+	 * be compared with a tagged address, e.g. macros such as PAGE_MASK
+	 * or struct members named .vm_start. 
+	 */
+	if (expr_has_memory_addr(expr->left))
+		val = expr->right;
+
+	/*
+	 * The macro 'offset_in_page' has the PAGE_MASK macro inside it, this
+	 * results in 'expr_has_memory_addr' returning true for both sides. To
+	 * work around this we assume PAGE_MASK (or similar) is on the right
+	 * side, thus we do the following test last.
+	 */
+	if (expr_has_memory_addr(expr->right))
+		val = expr->left;
+
+	if (!val)
+		return;
+
+	/* We only care about memory addresses which are 64 bits */
+        type = get_type(val);
+	if (!type || type_bits(type) != 64)
+		return;
+
+	/* We only care for comparison against user originated data */
+	if (!get_user_rl(val, &rl))
+		return;
+
+	/* We only care for tagged addresses */
+	if (!rl_is_tagged(rl))
+		return;
+
+	/* Finally, we believe we may have spotted a risky comparison */
+	var_name = expr_to_var(val);
+	if (var_name)
+		sm_warning("comparison of a potentially tagged address (%s, %d, %s)", get_function(), get_param_num(val), var_name);
+}
+
+void check_arm64_tagged(int id)
+{
+	char *arch;
+
+	if (option_project != PROJ_KERNEL)
+		return;
+
+	/* Limit to aarch64 */
+	arch = getenv("ARCH");
+	if (!arch || strcmp(arch, "arm64"))
+		return;
+
+	symbols = create_function_hashtable(4000);
+
+	add_hook(&match_assign, ASSIGNMENT_HOOK);
+	add_hook(&match_condition, CONDITION_HOOK);
+	add_hook(&match_endfunc, END_FUNC_HOOK);
+}
--- old/usr/src/tools/smatch/src/check_check_deref.c	Mon Nov 18 13:18:42 2019
+++ new/usr/src/tools/smatch/src/check_check_deref.c	Mon Nov 18 13:18:42 2019
@@ -135,8 +135,11 @@
 static void match_condition(struct expression *expr)
 {
 	struct smatch_state *true_state = NULL;
+	char *name;
 
-	if (get_macro_name(expr->pos))
+	name = get_macro_name(expr->pos);
+	if (name &&
+	    (strcmp(name, "likely") != 0 && strcmp(name, "unlikely") != 0))
 		return;
 
 	if (!is_pointer(expr))
--- old/usr/src/tools/smatch/src/check_continue_vs_break.c	Mon Nov 18 13:18:42 2019
+++ new/usr/src/tools/smatch/src/check_continue_vs_break.c	Mon Nov 18 13:18:42 2019
@@ -36,7 +36,7 @@
 {
 	if (!stmt->iterator_post_condition)
 		return 0;
-	if (!is_zero(stmt->iterator_post_condition))
+	if (!expr_is_zero(stmt->iterator_post_condition))
 		return 0;
 	return 1;
 }
--- old/usr/src/tools/smatch/src/check_debug.c	Mon Nov 18 13:18:42 2019
+++ new/usr/src/tools/smatch/src/check_debug.c	Mon Nov 18 13:18:42 2019
@@ -22,6 +22,7 @@
 void show_sname_alloc(void);
 void show_data_range_alloc(void);
 void show_ptrlist_alloc(void);
+void show_rl_ptrlist_alloc(void);
 void show_sm_state_alloc(void);
 
 int local_debug;
@@ -204,6 +205,7 @@
 {
 	struct expression *arg;
 	struct range_list *rl = NULL;
+	bool capped = false;
 	char *name;
 
 	arg = get_argument_from_call_expr(expr->args, 0);
@@ -210,7 +212,9 @@
 	name = expr_to_str(arg);
 
 	get_user_rl(arg, &rl);
-	sm_msg("user rl: '%s' = '%s'", name, show_rl(rl));
+	if (rl)
+		capped = user_rl_capped(arg);
+	sm_msg("user rl: '%s' = '%s'%s", name, show_rl(rl), capped ? " (capped)" : "");
 
 	free_string(name);
 }
@@ -687,6 +691,8 @@
 static void match_mem(const char *fn, struct expression *expr, void *info)
 {
 	show_sname_alloc();
+	show_data_range_alloc();
+	show_rl_ptrlist_alloc();
 	show_ptrlist_alloc();
 	sm_msg("%lu pools", get_pool_count());
 	sm_msg("%d strees", unfree_stree);
--- old/usr/src/tools/smatch/src/check_deref.c	Mon Nov 18 13:18:43 2019
+++ new/usr/src/tools/smatch/src/check_deref.c	Mon Nov 18 13:18:43 2019
@@ -186,7 +186,7 @@
 {
 	struct statement *stmt;
 
-	if (!is_zero(expr->right))
+	if (!expr_is_zero(expr->right))
 		return;
 
 	if (__in_fake_assign)
--- old/usr/src/tools/smatch/src/check_deref_check.c	Mon Nov 18 13:18:43 2019
+++ new/usr/src/tools/smatch/src/check_deref_check.c	Mon Nov 18 13:18:43 2019
@@ -66,11 +66,14 @@
 static void match_condition(struct expression *expr)
 {
 	struct sm_state *sm;
+	char *name;
 
 	if (__in_pre_condition)
 		return;
 
-	if (get_macro_name(expr->pos))
+	name = get_macro_name(expr->pos);
+	if (name &&
+	    (strcmp(name, "likely") != 0 && strcmp(name, "unlikely") != 0))
 		return;
 
 	if (!is_pointer(expr))
--- old/usr/src/tools/smatch/src/check_dereferences_param.c	Mon Nov 18 13:18:43 2019
+++ new/usr/src/tools/smatch/src/check_dereferences_param.c	Mon Nov 18 13:18:43 2019
@@ -78,8 +78,6 @@
 {
 	if (expr->type != EXPR_PREOP)
 		return;
-	if (getting_address())
-		return;
 	check_deref(expr->unop);
 }
 
--- old/usr/src/tools/smatch/src/check_double_checking.c	Mon Nov 18 13:18:44 2019
+++ new/usr/src/tools/smatch/src/check_double_checking.c	Mon Nov 18 13:18:44 2019
@@ -47,9 +47,9 @@
 	if (expr->type == EXPR_COMPARE &&
 	    (expr->op == SPECIAL_EQUAL ||
 	     expr->op == SPECIAL_NOTEQUAL)) {
-		if (is_zero(expr->left))
+		if (expr_is_zero(expr->left))
 			return strip_condition(expr->right);
-		if (is_zero(expr->right))
+		if (expr_is_zero(expr->right))
 			return strip_condition(expr->left);
 	}
 
@@ -131,6 +131,9 @@
 	struct position prev_pos;
 	char *ident;
 
+	if (!__cur_stmt)
+		return 0;
+
 	if (__prev_stmt) {
 		prev_pos = __prev_stmt->pos;
 		prev_pos.line -= 3;
--- old/usr/src/tools/smatch/src/check_free.c	Mon Nov 18 13:18:44 2019
+++ new/usr/src/tools/smatch/src/check_free.c	Mon Nov 18 13:18:44 2019
@@ -36,10 +36,10 @@
 		set_state(my_id, sm->name, sm->sym, &ok);
 }
 
-static void pre_merge_hook(struct sm_state *sm)
+static void pre_merge_hook(struct sm_state *cur, struct sm_state *other)
 {
 	if (is_impossible_path())
-		set_state(my_id, sm->name, sm->sym, &ok);
+		set_state(my_id, cur->name, cur->sym, &ok);
 }
 
 static int is_freed(struct expression *expr)
--- old/usr/src/tools/smatch/src/check_free_strict.c	Mon Nov 18 13:18:45 2019
+++ new/usr/src/tools/smatch/src/check_free_strict.c	Mon Nov 18 13:18:45 2019
@@ -36,12 +36,29 @@
 		set_state(my_id, sm->name, sm->sym, &ok);
 }
 
-static void pre_merge_hook(struct sm_state *sm)
+static void pre_merge_hook(struct sm_state *cur, struct sm_state *other)
 {
 	if (is_impossible_path())
-		set_state(my_id, sm->name, sm->sym, &ok);
+		set_state(my_id, cur->name, cur->sym, &ok);
 }
 
+static struct smatch_state *unmatched_state(struct sm_state *sm)
+{
+	struct smatch_state *state;
+	sval_t sval;
+
+	if (sm->state != &freed)
+		return &undefined;
+
+	state = get_state(SMATCH_EXTRA, sm->name, sm->sym);
+	if (!state)
+		return &undefined;
+	if (!estate_get_single_value(state, &sval) || sval.value != 0)
+		return &undefined;
+	/* It makes it easier to consider NULL pointers as freed.  */
+	return &freed;
+}
+
 static int is_freed(struct expression *expr)
 {
 	struct sm_state *sm;
@@ -341,6 +358,7 @@
 
 	add_modification_hook_late(my_id, &ok_to_use);
 	add_pre_merge_hook(my_id, &pre_merge_hook);
+	add_unmatched_state_hook(my_id, &unmatched_state);
 
 	select_return_states_hook(PARAM_FREED, &set_param_freed);
 	add_untracked_param_hook(&match_untracked);
--- old/usr/src/tools/smatch/src/check_get_user_overflow.c	Mon Nov 18 13:18:45 2019
+++ new/usr/src/tools/smatch/src/check_get_user_overflow.c	Mon Nov 18 13:18:45 2019
@@ -108,7 +108,7 @@
 		return;
 	}
 	name = expr_to_var(expr->right);
-	if (!name || strcmp(name, "__val_gu") != 0)
+	if (!name || (strcmp(name, "__val_gu") != 0 && strcmp(name, "__gu_val")))
 		goto free;
 	set_state_expr(my_max_id, expr->left, &user_data);
 	set_state_expr(my_min_id, expr->left, &user_data);
@@ -127,14 +127,15 @@
 
 	sm = get_sm_state_expr(my_max_id, expr);
 	if (sm && slist_has_state(sm->possible, &user_data)) {
-		if (!get_absolute_max(expr, &max) || sval_cmp_val(max, 20000) > 0)
+		get_absolute_max(expr, &max);
+		if (sval_cmp_val(max, 20000) > 0)
 			overflow = 1;
 	}
 
 	sm = get_sm_state_expr(my_min_id, expr);
 	if (sm && slist_has_state(sm->possible, &user_data)) {
-		if (!get_absolute_min(expr, &sval) ||
-		    (sval_is_negative(sval) && sval_cmp_val(sval, -20000) < 0))
+		get_absolute_min(expr, &sval);
+		if (sval_is_negative(sval) && sval_cmp_val(sval, -20000) < 0)
 			underflow = 1;
 	}
 
--- old/usr/src/tools/smatch/src/check_kernel.c	Mon Nov 18 13:18:45 2019
+++ new/usr/src/tools/smatch/src/check_kernel.c	Mon Nov 18 13:18:45 2019
@@ -104,14 +104,18 @@
 {
 	int param = PTR_INT(_param);
 	struct expression *arg;
-	struct range_list *rl;
+	struct range_list *pre, *rl;
 	struct smatch_state *pre_state;
 	struct smatch_state *end_state;
 
 	arg = get_argument_from_call_expr(call_expr->args, param);
 	pre_state = get_state_expr(SMATCH_EXTRA, arg);
+	if (pre_state)
+		pre = estate_rl(pre_state);
+	else
+		pre = alloc_whole_rl(&ptr_ctype);
 	call_results_to_rl(call_expr, &ptr_ctype, "0,(-4095)-(-1)", &rl);
-	rl = rl_intersection(estate_rl(pre_state), rl);
+	rl = rl_intersection(pre, rl);
 	rl = cast_rl(get_type(arg), rl);
 	end_state = alloc_estate_rl(rl);
 	set_extra_expr_nomod(arg, end_state);
--- old/usr/src/tools/smatch/src/check_list.h	Mon Nov 18 13:18:46 2019
+++ new/usr/src/tools/smatch/src/check_list.h	Mon Nov 18 13:18:46 2019
@@ -40,7 +40,6 @@
 CK(register_comparison_links)
 CK(register_comparison_inc_dec)
 CK(register_comparison_inc_dec_links)
-CK(register_local_values)
 CK(register_function_ptrs)
 CK(register_annotate)
 CK(register_start_states)
@@ -48,7 +47,6 @@
 CK(register_data_source)
 CK(register_common_functions)
 CK(register_function_info)
-CK(register_auto_copy)
 CK(register_type_links)
 CK(register_impossible)
 CK(register_impossible_return)
@@ -178,6 +176,7 @@
 CK(check_return_negative_var)
 CK(check_rosenberg)
 CK(check_rosenberg2)
+CK(check_rosenberg3)
 CK(check_wait_for_common)
 CK(check_bogus_irqrestore)
 CK(check_zero_to_err_ptr)
@@ -197,6 +196,8 @@
 CK(check_wine_filehandles)
 CK(check_wine_WtoA)
 
+CK(check_arm64_tagged)
+
 /* illumos specific */
 CK(check_all_func_returns)
 CK(check_cmn_err)
--- old/usr/src/tools/smatch/src/check_locking.c	Mon Nov 18 13:18:46 2019
+++ new/usr/src/tools/smatch/src/check_locking.c	Mon Nov 18 13:18:46 2019
@@ -456,10 +456,10 @@
 	return &start_state;
 }
 
-static void pre_merge_hook(struct sm_state *sm)
+static void pre_merge_hook(struct sm_state *cur, struct sm_state *other)
 {
 	if (is_impossible_path())
-		set_state(my_id, sm->name, sm->sym, &impossible);
+		set_state(my_id, cur->name, cur->sym, &impossible);
 }
 
 static bool nestable(const char *name)
--- old/usr/src/tools/smatch/src/check_memset.c	Mon Nov 18 13:18:46 2019
+++ new/usr/src/tools/smatch/src/check_memset.c	Mon Nov 18 13:18:47 2019
@@ -19,16 +19,13 @@
 
 static int my_id;
 
-static void match_memset(const char *fn, struct expression *expr, void *data)
+static void check_size_not_zero(struct expression *expr)
 {
-	struct expression *arg_expr;
 	sval_t sval;
 
-	arg_expr = get_argument_from_call_expr(expr->args, 2);
-
-	if (arg_expr->type != EXPR_VALUE)
+	if (expr->type != EXPR_VALUE)
 		return;
-	if (!get_value(arg_expr, &sval))
+	if (!get_value(expr, &sval))
 		return;
 	if (sval.value != 0)
 		return;
@@ -35,6 +32,26 @@
 	sm_error("calling memset(x, y, 0);");
 }
 
+static void check_size_not_ARRAY_SIZE(struct expression *expr)
+{
+	char *name;
+
+	name = get_macro_name(expr->pos);
+	if (name && strcmp(name, "ARRAY_SIZE") == 0)
+		sm_warning("calling memset(x, y, ARRAY_SIZE());");
+}
+
+static void match_memset(const char *fn, struct expression *expr, void *data)
+{
+	struct expression *arg_expr;
+
+	arg_expr = get_argument_from_call_expr(expr->args, 2);
+	if (!arg_expr)
+		return;
+	check_size_not_zero(arg_expr);
+	check_size_not_ARRAY_SIZE(arg_expr);
+}
+
 void check_memset(int id)
 {
 	my_id = id;
--- old/usr/src/tools/smatch/src/check_nospec.c	Mon Nov 18 13:18:47 2019
+++ new/usr/src/tools/smatch/src/check_nospec.c	Mon Nov 18 13:18:47 2019
@@ -179,6 +179,8 @@
 
 	if (!stmt || stmt->type != STMT_ASM)
 		return 0;
+	if (!stmt->asm_string)
+		return 0;
 	macro = get_macro_name(stmt->asm_string->pos);
 	if (!macro || strcmp(macro, "CALL_NOSPEC") != 0)
 		return 0;
--- old/usr/src/tools/smatch/src/check_readl_infinite_loops.c	Mon Nov 18 13:18:47 2019
+++ new/usr/src/tools/smatch/src/check_readl_infinite_loops.c	Mon Nov 18 13:18:47 2019
@@ -126,7 +126,7 @@
 
 	if (!stmt || stmt->type != STMT_ITERATOR)
 		return;
-	if (ptr_list_empty(state_at_start))
+	if (ptr_list_empty((struct ptr_list *)state_at_start))
 		returned = 0;
 	state = get_state(my_id, "depends on", NULL);
 	push_state_at_start(state);
--- old/usr/src/tools/smatch/src/check_rosenberg.c	Mon Nov 18 13:18:48 2019
+++ new/usr/src/tools/smatch/src/check_rosenberg.c	Mon Nov 18 13:18:48 2019
@@ -28,6 +28,7 @@
 
 static int my_whole_id;
 static int my_member_id;
+static int skb_put_id;
 
 STATE(cleared);
 
@@ -124,19 +125,6 @@
 	return toplevel(sym->scope);
 }
 
-static int was_initialized(struct expression *expr)
-{
-	struct symbol *sym;
-	char *name;
-
-	name = expr_to_var_sym(expr, &sym);
-	if (!name)
-		return 0;
-	if (sym->initializer)
-		return 1;
-	return 0;
-}
-
 static void match_clear(const char *fn, struct expression *expr, void *_arg_no)
 {
 	struct expression *ptr;
@@ -258,8 +246,21 @@
 
 	if (has_global_scope(data))
 		return;
-	if (was_initialized(data))
+	if (was_memset(data))
 		return;
+	if (warn_on_holey_struct(data))
+		return;
+	check_members_initialized(data);
+}
+
+static void check_skb_put(struct expression *data)
+{
+	data = strip_expr(data);
+	if (!data)
+		return;
+	if (data->type == EXPR_PREOP && data->op == '&')
+		data = strip_expr(data->unop);
+
 	if (was_memset(data))
 		return;
 	if (warn_on_holey_struct(data))
@@ -291,16 +292,51 @@
 	match_clear(NULL, expr, INT_PTR(param));
 }
 
-static void match_assign(struct expression *expr)
+static struct smatch_state *alloc_expr_state(struct expression *expr)
 {
+	struct smatch_state *state;
+	char *name;
+
+	name = expr_to_str(expr);
+	if (!name)
+		return NULL;
+
+	state = __alloc_smatch_state(0);
+	expr = strip_expr(expr);
+	state->name = alloc_sname(name);
+	free_string(name);
+	state->data = expr;
+	return state;
+}
+
+static void match_skb_put(const char *fn, struct expression *expr, void *unused)
+{
 	struct symbol *type;
+	struct smatch_state *state;
 
 	type = get_type(expr->left);
+	type = get_real_base_type(type);
 	if (!type || type->type != SYM_STRUCT)
 		return;
-	set_state_expr(my_whole_id, expr->left, &cleared);
+	state = alloc_expr_state(expr->left);
+	set_state_expr(skb_put_id, expr->left, state);
 }
 
+static void match_return_skb_put(struct expression *expr)
+{
+	struct sm_state *sm;
+	struct stree *stree;
+
+	if (is_error_return(expr))
+		return;
+
+	stree = __get_cur_stree();
+
+	FOR_EACH_MY_SM(skb_put_id, stree, sm) {
+		check_skb_put(sm->state->data);
+	} END_FOR_EACH_SM(sm);
+}
+
 static void register_clears_argument(void)
 {
 	struct token *token;
@@ -369,7 +405,6 @@
 	add_function_hook("__builtin_memset", &match_clear, INT_PTR(0));
 	add_function_hook("__builtin_memcpy", &match_clear, INT_PTR(0));
 
-	add_hook(&match_assign, ASSIGNMENT_HOOK);
 	register_clears_argument();
 	select_return_states_hook(PARAM_CLEARED, &db_param_cleared);
 
@@ -386,3 +421,14 @@
 	add_extra_mod_hook(&extra_mod_hook);
 }
 
+void check_rosenberg3(int id)
+{
+	if (option_project != PROJ_KERNEL)
+		return;
+
+	skb_put_id = id;
+	set_dynamic_states(skb_put_id);
+	add_function_assign_hook("skb_put", &match_skb_put, NULL);
+	add_hook(&match_return_skb_put, RETURN_HOOK);
+}
+
--- old/usr/src/tools/smatch/src/check_testing_index_after_use.c	Mon Nov 18 13:18:48 2019
+++ new/usr/src/tools/smatch/src/check_testing_index_after_use.c	Mon Nov 18 13:18:48 2019
@@ -58,7 +58,7 @@
 	if (buf_comparison_index_ok(expr))
 		return;
 
-	if (getting_address())
+	if (getting_address(expr))
 		return;
 	if (is_capped(offset))
 		return;
--- old/usr/src/tools/smatch/src/check_uninitialized.c	Mon Nov 18 13:18:48 2019
+++ new/usr/src/tools/smatch/src/check_uninitialized.c	Mon Nov 18 13:18:48 2019
@@ -24,10 +24,10 @@
 STATE(uninitialized);
 STATE(initialized);
 
-static void pre_merge_hook(struct sm_state *sm)
+static void pre_merge_hook(struct sm_state *cur, struct sm_state *other)
 {
 	if (is_impossible_path())
-		set_state(my_id, sm->name, sm->sym, &initialized);
+		set_state(my_id, cur->name, cur->sym, &initialized);
 }
 
 static void mark_members_uninitialized(struct symbol *sym)
@@ -113,7 +113,7 @@
 
 	if (expr->type != EXPR_COMPARE || expr->op != '<')
 		return;
-	if (!is_zero(expr->right))
+	if (!expr_is_zero(expr->right))
 		return;
 	if (get_implied_max(expr->left, &max) && max.value == 0)
 		return;
--- old/usr/src/tools/smatch/src/check_unwind.c	Mon Nov 18 13:18:49 2019
+++ new/usr/src/tools/smatch/src/check_unwind.c	Mon Nov 18 13:18:49 2019
@@ -125,7 +125,7 @@
 	if (!type || type->type != SYM_FN)
 		return 0;
 	type = get_base_type(type);
-	if (type->ctype.base_type == &int_type) {
+	if (type && type->ctype.base_type == &int_type) {
 		return 1;
 	}
 	return 0;
--- old/usr/src/tools/smatch/src/compat.h	Mon Nov 18 13:18:49 2019
+++ new/usr/src/tools/smatch/src/compat.h	Mon Nov 18 13:18:49 2019
@@ -10,8 +10,6 @@
  *  - "string to long double" (C99 strtold())
  *	Missing in Solaris and MinGW
  */
-struct stream;
-struct stat;
 
 /*
  * Our "blob" allocator works on chunks that are multiples
--- old/usr/src/tools/smatch/src/compile-i386.c	Mon Nov 18 13:18:49 2019
+++ new/usr/src/tools/smatch/src/compile-i386.c	Mon Nov 18 13:18:49 2019
@@ -193,7 +193,6 @@
 static void emit_comment(const char * fmt, ...) FORMAT_ATTR(1);
 static void emit_move(struct storage *src, struct storage *dest,
 		      struct symbol *ctype, const char *comment);
-static int type_is_signed(struct symbol *sym);
 static struct storage *x86_address_gen(struct expression *expr);
 static struct storage *x86_symbol_expr(struct symbol *sym);
 static void x86_symbol(struct symbol *sym);
@@ -452,7 +451,7 @@
 		strcpy(name, s->reg->name);
 		break;
 	case STOR_VALUE:
-		sprintf(name, "$%Ld", s->value);
+		sprintf(name, "$%lld", s->value);
 		break;
 	case STOR_LABEL:
 		sprintf(name, "%s.L%d", s->flags & STOR_LABEL_VAL ? "$" : "",
@@ -937,7 +936,7 @@
 
 	assert(type != NULL);
 
-	printf("\t.%s\t%Ld\n", type, ll);
+	printf("\t.%s\t%lld\n", type, ll);
 }
 
 static void emit_global_noinit(const char *name, unsigned long modifiers,
@@ -1163,7 +1162,7 @@
 
 	if (ctype) {
 		bits = ctype->bit_size;
-		is_signed = type_is_signed(ctype);
+		is_signed = is_signed_type(ctype);
 	} else {
 		bits = 32;
 		is_signed = 0;
@@ -1355,7 +1354,7 @@
 	if ((expr->op == '/') || (expr->op == '%'))
 		return emit_divide(expr, left, right);
 
-	is_signed = type_is_signed(expr->ctype);
+	is_signed = is_signed_type(expr->ctype);
 
 	switch (expr->op) {
 	case '+':
@@ -1555,7 +1554,7 @@
 
 static struct storage *emit_conditional_expr(struct expression *expr)
 {
-	struct storage *cond, *true = NULL, *false = NULL;
+	struct storage *cond, *stot = NULL, *stof = NULL;
 	struct storage *new = stack_alloc(expr->ctype->bit_size / 8);
 	int target_false, cond_end;
 
@@ -1564,16 +1563,16 @@
 	target_false = emit_conditional_test(cond);
 
 	/* handle if-true part of the expression */
-	true = x86_expression(expr->cond_true);
+	stot = x86_expression(expr->cond_true);
 
-	emit_copy(new, true, expr->ctype);
+	emit_copy(new, stot, expr->ctype);
 
 	cond_end = emit_conditional_end(target_false);
 
 	/* handle if-false part of the expression */
-	false = x86_expression(expr->cond_false);
+	stof = x86_expression(expr->cond_false);
 
-	emit_copy(new, false, expr->ctype);
+	emit_copy(new, stof, expr->ctype);
 
 	/* end of conditional; jump target for if-true branch */
 	emit_label(cond_end, "end conditional");
@@ -1584,15 +1583,15 @@
 static struct storage *emit_select_expr(struct expression *expr)
 {
 	struct storage *cond = x86_expression(expr->conditional);
-	struct storage *true = x86_expression(expr->cond_true);
-	struct storage *false = x86_expression(expr->cond_false);
+	struct storage *stot = x86_expression(expr->cond_true);
+	struct storage *stof = x86_expression(expr->cond_false);
 	struct storage *reg_cond, *reg_true, *reg_false;
 	struct storage *new = stack_alloc(4);
 
 	emit_comment("begin SELECT");
 	reg_cond = get_reg_value(cond, get_regclass(expr->conditional));
-	reg_true = get_reg_value(true, get_regclass(expr));
-	reg_false = get_reg_value(false, get_regclass(expr));
+	reg_true = get_reg_value(stot, get_regclass(expr));
+	reg_false = get_reg_value(stof, get_regclass(expr));
 
 	/*
 	 * Do the actual select: check the conditional for zero,
@@ -2236,7 +2235,7 @@
 		return new;
 	}
 	if (sym->ctype.modifiers & MOD_ADDRESSABLE) {
-		printf("\taddi.%d\t\tv%d,vFP,$%lld\n", bits_in_pointer, new->pseudo, sym->value);
+		printf("\taddi.%d\t\tv%d,vFP,$%lld\n", bits_in_pointer, new->pseudo, 0LL);
 		return new;
 	}
 	printf("\taddi.%d\t\tv%d,vFP,$offsetof(%s:%p)\n", bits_in_pointer, new->pseudo, show_ident(sym->ident), sym);
@@ -2264,15 +2263,6 @@
 	priv->addr = new;
 }
 
-static int type_is_signed(struct symbol *sym)
-{
-	if (sym->type == SYM_NODE)
-		sym = sym->ctype.base_type;
-	if (sym->type == SYM_PTR)
-		return 0;
-	return !(sym->ctype.modifiers & MOD_UNSIGNED);
-}
-
 static struct storage *x86_label_expr(struct expression *expr)
 {
 	struct storage *new = stack_alloc(4);
--- old/usr/src/tools/smatch/src/compile.c	Mon Nov 18 13:18:50 2019
+++ new/usr/src/tools/smatch/src/compile.c	Mon Nov 18 13:18:50 2019
@@ -59,7 +59,7 @@
 	bits_in_bool = 8;
 
 	clean_up_symbols(sparse_initialize(argc, argv, &filelist));
-	FOR_EACH_PTR_NOTAG(filelist, file) {
+	FOR_EACH_PTR(filelist, file) {
 		struct symbol_list *list;
 		const char *basename = strrchr(file, '/');
 		basename = basename ?  basename+1 : file;
@@ -70,7 +70,7 @@
 		emit_unit_begin(basename);
 		clean_up_symbols(list);
 		emit_unit_end();
-	} END_FOR_EACH_PTR_NOTAG(file);
+	} END_FOR_EACH_PTR(file);
 
 #if 0
 	// And show the allocation statistics
